# Musterlösung zum zweiten Aufgabenblatt
# Algorithmen und Programmieren II (SS 2012)

# --------- Aufgabe 1 ----------

from math import sqrt, sin, cos, atan2, atan, acos

def decide_color_rects(x, y, size):
        """Normalisiert die Werte auf eine Skala von 0 bis 5 (inkl.)"""

        (x, y) = (x * 6 // size, y * 6 // size)
        if 2 <= x < 4 and 2 <= y < 4 and not (x == y == 3):
            return "light salmon"
        return "black"

def decide_color_circle(x, y, size):
        """Berechnet den Abstand vom Mittelpunkt."""

        r = sqrt ((x - size / 2) ** 2 + (y - size / 2) ** 2)
        if r < 60:
            if x < size / 2:
                return "red"
            return "black"
        if y > size / 2:
            return "light gray"
        return "white"
        
def decide_color_squares(x, y, size):
        var = y
        if (x > y) != (size - x > y):
            var = x
        if var > size / 2:
            var -= size
        if (var - 1) % 4 < 2:
            return "white"
        return "blue"
                                
def decide_color_illusion(x, y, size):
        var = x
        if x * 8 // size % 2 == y * 8 // size % 2:
            var = y
        if var % 5 == 0:
            return "black"
        return "white"

def decide_color_illusion2(x, y, size):
        if 2 <= x * 6 // size < 4 and 2 <= y * 6 // size < 4:
            return "magenta"
        if x % 7 > 1 and y % 7 > 1:
            return "black"
        return "white"
                
def decide_color_own1(x, y, size):
        """ Zeichnet diagonale, grüne, 4 pixel breite Linien auf weißem Grund. """

        size /= 3
        x %= size
        y %= size
        if y - 3 < x < y + 3 or size - y - 3 < x < size - y + 3:
            return "green"
        return "white"

def decide_color_own2(x, y, size):
        """ Ein blauer Farbverlauf von oben links nach unten rechts.

            Die Farbe wird zusammengesetzt, denn TK akzeptiert auch Farbnamen
            in der Art #RRGGBB, wobei RR GG und BB für hexadezimale Werte zwischen
            00 und FF steht.

            Eigentlich wird hier die Funktion f (x, y) = x + y geplottet. """

        return "#" + hex((x + y) * 255 // (size * 2))[2:].zfill(2) * 2 + "FF"

def decide_color_homework_2011(x, y, size):
        n = 9
        m = size//n
        n3 = n//3
        if (y%m)==0:
                return "gray"
        elif ((y//m)%4)==0 and ((x//m)%2)==0:
                return "black"
        elif ((y//m)%4)==1 and (((x+n3)//m)%2)==0:
                return "black"
        elif ((y//m)%4)==2 and (((x+2*n3)//m)%2)==0:
                return "black"
        elif ((y//m)%4)==3 and (((x+n3)//m)%2)==0:
                return "black"
        else:
                return "white"

def decide_color_new(x, y, size):

        xm = x-size/2
        ym = y-size/2
        delta = 10
        
        r = sqrt(xm*xm+ym*ym)
        t = cos(xm)*size/2.5
        t2 = cos(ym)*size/2.5

        if t-delta<=int(r)<=t+delta or t2-delta<=int(r)<=t2+delta:
                return "black"
        else:
                return "white"

